# R[h1.5
library(glmnet)

# f[^̓ǂݍ݂Ɗ
url<- "https://archive.ics.uci.edu/ml/machine-learning-databases/concrete/slump/slump_test.data"
data<- read.csv(url, header=TRUE)[, -1]

x<- data[, 1:7]
y<- data[, 9]

x<- scale(x)
y<- y-mean(y)

# 10ؖ@ɂCV덷̃vbg
cv.lasso <- cv.glmnet(x, y, family = "gaussian", alpha = 1, nfolds = 10)

plot(cv.lasso, xlab="Log Lambda", ylab="CV Error", cex.axis=1.5, cex.lab=1.5)
grid()

# 1ؖ@̏ꍇ͎̂悤ɂƗǂ
# cv.lasso<- cv.glmnet(x, y, family = "gaussian", alpha=1, nfolds=nrow(x), grouped=FALSE)

# IlambdapƂ̃b\l
# CV덷ŏɂlambdapꍇ
lambda.min<- cv.lasso$lambda.min
glmnet(x, y, family = "gaussian", lambda = lambda.min , alpha = 1)$beta

# 1W덷ɂlambda pꍇ
lambda.1se<- cv.lasso$lambda.1se
glmnet(x, y, family = "gaussian", lambda = lambda.1se , alpha = 1)$beta




