#### R[h2.1, R[h4.1

### R[h2.1

## IWif[^UCI ML databaseǂݍ
Wine = read.csv(
  url("https://archive.ics.uci.edu/ml/machine-learning-databases/wine/wine.data"), 
  header = FALSE
)

## gpϐ(i, t{mChܗL, Fx)𒊏o
wine = Wine[, c(1, 8, 11)]
colnames(wine) = c("grape", "x1", "x2")          # 3ϐ̖

## TvTCY̌vZ
# i킲
n1 = sum(wine[, 1] == 1)
n2 = sum(wine[, 1] == 2)
n3 = sum(wine[, 1] == 3)
# g[^
n = n1 + n2 + n3

## pĊei킩狳tTvI(tTvTCY͕\2.1̐ݒ)
n1.train = 29; n2.train = 36; n3.train = 24      # ei̋tTvTCY
set.seed(380)                                    # w
# tTv(i1)
train1 = sort(sample(which(wine[, 1] == 1), n1.train))
# tTv(i2)
train2 = sort(sample(which(wine[, 1] == 2), n2.train))
# tTv(i3)
train3 = sort(sample(which(wine[, 1] == 3), n3.train))
# tTv(Si)
train  = c(train1, train2, train3)

## ceXgTvƂ
# eĩeXgTvTCY
n1.test = n1 - n1.train
n2.test = n2 - n2.train
n3.test = n3 - n3.train
# eXgTv(Si)
test = (1:n)[-train]

## tf[^EeXgf[^֕
wine.train = wine[train, ];  wine.test  = wine[test, ]

## :x1, c:x2 ŎUz}쐬(}2.1ɑΉ)
r1 = range(wine[, 2]); r2 = range(wine[, 3])     # x1, x2 ̒l
par(mfrow = c(1, 2))                             # vbgʂ2 

# tf[^̎Uz}
plot(wine.train[, 2], wine.train[, 3], xlim = r1, ylim = r2,  
     xlab = "x1", ylab = "x2", col = wine.train[, 1], pch = wine.train[, 1],
     main = paste0("training; n1 = ", n1.train, ", n2 = ", n2.train, ", n3 = ", n3.train))
legend("topright", legend = paste0("grape", 1:3), col = 1:3, pch = 1:3) 

# eXgf[^̎Uz} 
plot(wine.test[, 2], wine.test[, 3], xlim = r1, ylim = r2,  
     xlab = "x1", ylab = "x2", col = wine.test[, 1], pch = wine.test[, 1],
     main = paste0("test; n1 = ", n1.test, ", n2 = ", n2.test, ", n3 = ", n3.test))
legend("topright", legend = paste0("grape", 1:3), col = 1:3, pch = 1:3) 

par(mfrow = c(1, 1))         # vbgʂ̕ 

## ʋE}ۂɎgpiq_쐬
grid = data.frame(expand.grid(x1 = seq(r1[1], r1[2], length.out = 500),
                              x2 = seq(r2[1], r2[2], length.out = 500)))

### R[h4.1

## R package [e1071] 𗘗p 
library(e1071) 

## 5-fold cv Ńp[^`[jO 
tune = tune.svm(as.factor(grape) ~ ., data = wine.train, 
                kernel = "radial", gamma = 10^(seq(-2, 2, 0.1)), 
                cost = 10^(seq(-2, 2, 0.1)),  
                tunecontrol = tune.control(sampling = "cross", cross = 5)) 

## `[jOς݂̃p[^gSVMs 
SVM = svm(as.factor(grape) ~ ., data = wine.train,  
          method = "C-classification", kernel = "radial",  
          gamma = tune$best.parameters[1], cost = tune$best.parameters[2]) 

## tf[^ɑ΂锻ʌ 
# tf[^𔻕
svm.train = as.integer(predict(SVM)) 
print(table( = wine.train[, 1],  = svm.train))         # \ 
svm.err.train = mean(wine.train[, 1] != svm.train)             # 딻ʗ 
print(svm.err.train) 

## eXgf[^ɑ΂锻ʌ 
# eXgf[^𔻕 
svm.test = as.integer(predict(SVM, wine.test[, 2:3]))
print(table( = wine.test[, 1],  = svm.test))           # \ 
svm.err.test = mean(wine.test[, 1] != svm.test)                # 딻ʗ 
print(svm.err.test) 

## R[h2.1ō쐬iq_gridɑ΂Ĕʂs, ʋE쐬 
# iq_ɑ΂Ĕʂs 
svm.area = as.integer(predict(SVM, grid))
par(mfrow = c(1, 2))         # vbgʂ2 

# tf[^̎Uz} 
plot(grid, cex = 0.001, col = grey(0.3 + 0.2*svm.area), 
     xlim = r1, ylim = r2) 
par(new = TRUE) 
plot(wine.train[, 2], wine.train[, 3], xlim = r1, ylim = r2,  
     xlab = "", ylab = "", col = wine.train[, 1], pch = wine.train[, 1],
     main = paste0("SVM (training; n1 = ", n1.train,  
                   ", n2 = ", n2.train, ", n3 = ", n3.train, ") \n",  
                   "error rate = ", signif(svm.err.train, 4))) 
legend("topright", legend = paste0("grape", 1:3), col = 1:3, pch = 1:3) 

# eXgf[^̎Uz} 
plot(grid, cex = 0.001, col = grey(0.3 + 0.2*svm.area), 
     xlim = r1, ylim = r2) 
par(new = TRUE) 
plot(wine.test[, 2], wine.test[, 3], xlim = r1, ylim = r2,  
     xlab = "", ylab = "", col = wine.test[, 1], pch = wine.test[, 1],
     main = paste0("SVM (test; n1 = ", n1.test,  
                   ", n2 = ", n2.test, ", n3 = ", n3.test, ") \n",  
                   "error rate = ", signif(svm.err.test, 4))) 
legend("topright", legend = paste0("grape", 1:3), col = 1:3, pch = 1:3) 

par(mfrow = c(1, 1))         # vbgʂ̕ 
