# コード1.2
# パッケージはあらかじめインストールしておくこと
## install.packages("パッケージ名", depndencies=TRUE)
library(glmnet)
library(plotmo)

# データ(LifeCycleSavings)の取得と基準化
x <- scale(LifeCycleSavings[, 2:5])
y <- LifeCycleSavings[, 1] - mean(LifeCycleSavings[, 1])

lasso<- glmnet(x, y, family = "gaussian", alpha=1)
ridge<- glmnet(x, y, family = "gaussian", alpha=0)

# 当てはめ結果のプロット
plot_glmnet(lasso, xvar="lambda", label=TRUE, 
	lwd=2.5, cex=1.5, cex.axis=1.5, cex.lab=1.5)
grid()

plot_glmnet(ridge, xvar="lambda", label=TRUE, 
	lwd=2.5, cex=1.5, cex.axis=1.5, cex.lab=1.5)
grid()

